XojoCustom.XTension.hslider.setupDrag = function( theCanvas, theData){
	XojoCustom.XTension.hslider.makeData( theCanvas, theData);
	if (theData.blocked)
		return false;
	
	if (!e)
		var e = event;
	var mouseX = e.pageX - XojoCustom.XTension.hslider.findLeft( theCanvas);
	
	//are we within the paddle
	var paddleStart = ((theData.value - theData.min) * theData.perPixelChange) + 2;
	if ((mouseX > paddleStart) && (mouseX < (paddleStart + theData.paddleWidth))){
		theData.mouseStart = mouseX - paddleStart + 2; //+2 to remove border calculation here
		theData.isDragging = true;
		
		document.getElementById( theData.displayid).style.display = "block";
		Xojo.get( theData.displayid).style.top = (XojoCustom.XTension.hslider.findTop( theCanvas) - 65) + "px";
		return true;
	} else {
		return false;
	}
	
}

XojoCustom.XTension.hslider.makeData = function( theCanvas, theData){
	theData.valueAtDragStart = theData.value;
	theData.usableWidth = theCanvas.width - theData.paddleWidth - 4; //-4 for border paddleWidth is 25
	theData.actualRange = theData.max - theData.min;
	theData.perPixelChange = theData.usableWidth / theData.actualRange;
}


XojoCustom.XTension.hslider.mouseDown = function( theCanvas, theData){
	 if (XojoCustom.XTension.hslider.setupDrag( theCanvas, theData)){	
		XojoCustom.XTension.hslider.mouseMove( theCanvas, theData);
	}
}

XojoCustom.XTension.hslider.touchStart = function( theCanvas, theData){
	 if (XojoCustom.XTension.hslider.setupDrag( theCanvas, theData)){
		XojoCustom.XTension.hslider.touchMove( theCanvas, theData);
	}
}


XojoCustom.XTension.hslider.mouseMove = function( theCanvas, theData){
	if (! theData.isDragging){
		return;
	}
	var e = event;
	if (!e)
		var e = event;
		
	var localX = e.pageX - XojoCustom.XTension.hslider.findLeft( theCanvas) - theData.mouseStart;
	
	theData.value = theData.min + (localX / theData.perPixelChange);
	
	if (theData.value < theData.min)
		theData.value = theData.min;

	
	if (theData.value > theData.max)
		theData.value = theData.max;
		
	XojoCustom.XTension.hslider.drawSlider( theCanvas, theData);
}


XojoCustom.XTension.hslider.touchMove = function( theCanvas, theData){
	if (! theData.isDragging){
		return;
	}
	
	var e = event;
	if (!e)
		var e = event;
		
	e.preventDefault();
	var localX = e.pageX - XojoCustom.XTension.hslider.findLeft( theCanvas) - theData.mouseStart;
	
	//theData.value = theData.valueAtDragStart - (localX / theData.perPixelChange);
	theData.value = theData.min + (localX / theData.perPixelChange);
	
	if (theData.value < theData.min){
		theData.value = theData.min;
	}
	
	if (theData.value > theData.max){
		theData.value = theData.max;
	}
		
	XojoCustom.XTension.hslider.drawSlider( theCanvas, theData);
}


XojoCustom.XTension.hslider.mouseUp = function( theCanvas, theData){

	//alert( "in mouseUp 2 with theData=" + theData);

	if (theData.isDragging){
		Xojo.triggerServerEvent( theData.controlid, "changed", [theData.value]);
	}
	
	theData.isDragging = false;
	XojoCustom.XTension.hslider.drawSlider( theCanvas, theData); //to clear highlight
	Xojo.get( theData.displayid).style.display = "none";
}

XojoCustom.XTension.hslider.touchEnd = function( theCanvas, theData){
	if (theData.isDragging){
		Xojo.triggerServerEvent( theData.controlid, "changed", [theData.value]);
	}
	
	theData.isDragging = false;
	XojoCustom.XTension.hslider.drawSlider( theCanvas, theData); //to clear highlight
	Xojo.get( theData.displayid).style.display = "none";

	
}


XojoCustom.XTension.hslider.drawSlider = function( theCanvas, theData){

	if (! theCanvas)
		return;
		
	var ctx = theCanvas.getContext( "2d");
	
	
	//clear and draw the background
	ctx.clearRect( 0, 0, theCanvas.width, theCanvas.height);
	ctx.lineWidth = "2";
	

	//in this case we let the background show through.
	
	if (theData.blocked){
		ctx.fillStyle = "rgb( 200, 200, 200)";
		ctx.globalAlpha = 0.6;
		ctx.fillRect( 0, 0, theCanvas.width, theCanvas.height);
		ctx.globalAlpha = 1;
		ctx.strokeStyle = "grey";
	} else {
		ctx.strokeStyle = "black";
		if (theData.isDragging){
			ctx.fillStyle = "rgb( 125, 125, 250)";
		} else {
			ctx.fillStyle = "rgb( 99, 99, 99)";
		}
	}
	
	XojoCustom.XTension.hslider.roundRect( ctx, 1, 1, theCanvas.width-1, theCanvas.height-1, 10)
	ctx.stroke();
	
	
	//draw the paddle
	var paddleStart = ((theData.value - theData.min) * theData.perPixelChange) + 2
	XojoCustom.XTension.hslider.roundRect( ctx, paddleStart, 2, paddleStart + theData.paddleWidth, theCanvas.height-2, 10);
	ctx.fill();
	ctx.stroke();
	
	var canvasOffset = XojoCustom.XTension.hslider.findLeft( theCanvas);
	
	document.getElementById( theData.displayid).style.left = Math.round(((paddleStart + (theData.paddleWidth / 2)) - (75 / 2)) + canvasOffset )+ "px";
	document.getElementById( theData.displayid).innerHTML = "<b>" + Math.round( theData.value) + "</b>";	
}	

XojoCustom.XTension.hslider.findLeft = function( obj){
	var bodyRect = document.body.getBoundingClientRect(),
		elemRect = obj.getBoundingClientRect();
		return elemRect.left - bodyRect.left;
}
XojoCustom.XTension.hslider.findTop = function( obj){
	var bodyRect = document.body.getBoundingClientRect(),
		elemRect = obj.getBoundingClientRect();
		return elemRect.top - bodyRect.top;
}

XojoCustom.XTension.hslider.roundRect = function( ctx, sx, sy, ex, ey, r){
	var r2d = Math.PI / 180;
	
	ctx.beginPath();
	ctx.moveTo(sx+r,sy);
    ctx.lineTo(ex-r,sy);
    ctx.arc(ex-r,sy+r,r,r2d*270,r2d*360,false);
    ctx.lineTo(ex,ey-r);
    ctx.arc(ex-r,ey-r,r,r2d*0,r2d*90,false);
    ctx.lineTo(sx+r,ey);
    ctx.arc(sx+r,ey-r,r,r2d*90,r2d*180,false);
    ctx.lineTo(sx,sy+r);
    ctx.arc(sx+r,sy+r,r,r2d*180,r2d*270,false);
    ctx.closePath();

}